<?php
  require("common.php");
  
  if (!Common::checkSession()){
    header('Location: login.php');
    return;
  }
  
  $search = new Search();
  $search->start();
  $search->showView();
  
  class Search {
    private $values = array();
    
    public function start(){
      $v = &$this->values;
      $v["findKeyword"] = Common::getArgs("findKeyword");
      $v["findDateFrom"] = Common::getArgs("findDateFrom");
      $v["findDateTo"] = Common::getArgs("findDateTo");
      $v["findFileName"] = Common::getArgs("findFileName");
      $v["findSort"] = Common::getArgs("findSort");
      // print $v['findSort'];
      
      $v["showDetail"] = Common::getArgs("showDetail");
      $v["page"] = Common::getArgs("page",0);
      $v["maxOfPage"] = Common::getArgs("maxOfPage",2);
      
      $v["searchword"] = $this->convertKeyword($v["findKeyword"], Common::$RESERVED);
      // $searchword = $keyword;
      
      $v["hitnum"] = 0;
      $v["documents"] = array();
      
      $this->searchUseHyperEstraier();
      
    }
    
    
    public function showView(){
      $v = &$this->values;
      require("searchView.php");
    }
    
    
    private function searchUseHyperEstraier(){
      $v = &$this->values;
      
      if ($v['searchword'] == ""){
        return;
      }
      
      $attr = "";
      
      if ($v['findDateFrom'] != ""){
        $attr .= " -attr \"@mdate NUMGE ".$v['findDateFrom']."\" "; 
      }
      
      if ($v['findDateTo'] != ""){
        $tmpTime = strtotime($v['findDateTo']);
        if ($tmpTime){
          $nextDay = date("Y/m/d",strtotime("+1 day", $tmpTime));
          $attr .= " -attr \"@mdate NUMLT $nextDay\" ";
        }
      }
      
      if ($v['findFileName'] != ""){
        $attr .= " -attr \"@uri ISTRRX ".$v['findFileName']."\" ";
      }
      
      if ($v['findSort'] != ""){
        $attr .= " -ord \"".$v['findSort']."\" ";
      }
      
      $searchPath = "";
      foreach ($_SESSION["paths"] as $path => $name){
        $searchPath .= "|".$path;
      }
      if (mb_strlen($searchPath) > 0){
        $attr .= " -attr \"@uri ISTRRX (".mb_substr($searchPath,1).")\" ";
      }
      
      
      // $estcmd = '/opt/hyperestraier/bin/estcmd search -vx  -max '.$max.' -sk '.($page * $max).' '.$attr.' /home/centos/POI/estIndex/ "'. $v['searchword'] . '"';
      $estcmd = '/opt/hyperestraier/bin/estcmd search -vx  -max '.$v["maxOfPage"].' -sk '.($v["page"] * $v["maxOfPage"]).' -attr "@uri ISTRRX (xls|xlsx|sample)" '.$attr.' /home/centos/POI/estIndex/ "'. $v['searchword'] . '"';
      print $estcmd."<br>\n";
      
      $lines = array();
      $ret = "";
      $xml = "";
      exec($estcmd, $lines, $ret);
      if ($ret == 0){
        foreach($lines as $line){
          $xml .= $line."\n";
        }
      }
      $data = simplexml_load_string($xml);
      // // print_r($data);
      // // print_r($data->meta->total);
      // 
      $v["hitnum"] = (int)$data->meta->hit[0]->attributes()->number;
      // print($num."\n");
      // 
      $v["documents"] = $data->document;
    }
    
    
    private function convertKeyword($keyword, $reserved){
      // $keyword = str_replace(" ", " AND ", $keyword);
      // $keyword = mb_ereg_replace("　", " AND ", $keyword);
      $searchword = $keyword;
      $searchword = mb_ereg_replace("　", " ", $searchword);
      $searchword = trim($searchword);
      // $searchword = mb_ereg_replace(" +", " ", $searchword);
      $searchwords = mb_split(" +", $searchword);
      // print count($searchwords);
      $searchword = $searchwords[0];
      // if( isset($reserved["AND"])){
      // print "OK";
      // } else {
      // print "NG";
      // }
      for($i = 1; $i < count($searchwords); $i++){
        if (isset($reserved[$searchwords[$i]]) && isset($searchwords[$i+1]) ){
          $searchword .= " ".$searchwords[$i]." ".$searchwords[++$i];
        } else {
          $searchword .= " AND ".$searchwords[$i];
        }
      }
      print $searchword."<br>\n";
      return $searchword;
    }
  }
?>


